Given a string, find the first non-repeating character in it and return it's index. If it doesn't exist, return -1.
Examples:
s = "leetcode"
return 0.
s = "loveleetcode",
return 2.
Note: You may assume the string contain only lowercase letters.
代码
Approach #1 Linear time solution
Complexity Analysis
Time complexity : O(N) since we go through the string of length N two times.
Space complexity : O(N) since we have to keep a hash map with N elements.
class Solution {
public int firstUniqChar(String s) {
HashMap<Character, Integer> count = new HashMap<Character, Integer>();
int n = s.length();
for (int i = 0; i < n; i++) {
char c = s.charAt(i);
count.put(c, count.getOrDefault(c, 0) + 1);
}
for (int i = 0; i < n; i++) {
if (count.get(s.charAt(i)) == 1) {
return i;
}
}
return -1;
}
}
#2
public class Solution {
public int firstUniqChar(String s) {
int count [] = new int[26];
for (int i = 0; i < s.length(); i ++) {
count[s.charAt(i) - 'a'] ++;
}
for (int i = 0; i < s.length(); i ++) {
if (count[s.charAt(i) - 'a'] == 1) {
return i;
}
}
return -1;
}
}